import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { MarkerCollisionMode } from "./MarkerCollisionMode";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected cs(): SeriesView;
    o2(): void;
    qz(a: SeriesView): void;
    yv: ScatterBaseView;
    protected get_fw(): boolean;
    ai(): Axis[];
    kq(a: any, b: string): any;
    md(a: string): string;
    eb(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    protected b2(): SeriesHitTestMode;
    wn(a: Point): Rect;
    gw(a: Point, b: boolean): boolean;
    constructor();
    yu: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    aar: string;
    get zf(): IFastItemColumn$1<number>;
    set zf(a: IFastItemColumn$1<number>);
    private zd;
    aaz: string;
    get zg(): IFastItemColumn$1<number>;
    set zg(a: IFastItemColumn$1<number>);
    private ze;
    aab: string;
    aad: string;
    protected gb(): boolean;
    protected zu(): boolean;
    protected ht(): List$1<SeriesLayerPropertyOverlay>;
    private aa6;
    private aa7;
    aan: string;
    aav: string;
    aap: string;
    aax: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get acg(): Brush;
    set acg(a: Brush);
    static readonly abr: DependencyProperty;
    trendLineThickness: number;
    aci: PenLineCap;
    ach: DoubleCollection;
    trendLinePeriod: number;
    yr: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    z8: number;
    z7: number;
    y6: ScatterItemSearchMode;
    z6: number;
    p9(): void;
    yw: ScatterErrorBarSettings;
    protected q7(a: any, b: string, c: any, d: any): void;
    protected zr(): boolean;
    protected zq(): boolean;
    zl(a: any): boolean;
    zk(a: any): boolean;
    private abp;
    private acj;
    private ack;
    private aa1;
    protected zp(a: string, b: FastItemsSourceEventAction): boolean;
    protected pb(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    abg(a: ScatterFrame): void;
    abh(a: ScatterFrame, b: Clipper): void;
    ay(a: Axis): AxisRange;
    kn(a: Point): any;
    private y3;
    get y4(): ScatterItemSearchMode;
    set y4(a: ScatterItemSearchMode);
    protected y5(): ScatterItemSearchMode;
    j3(a: Point): number;
    ir(a: Point): number;
    protected z2(a: Point): number;
    private yk;
    private yl;
    protected z1(a: Point): number;
    private aa4;
    protected get_zo(): boolean;
    protected get zo(): boolean;
    private z5;
    protected z4(a: Point): number;
    protected z0(a: Point): number;
    protected z3(a: Point): number;
    wa(a: Point, b: boolean, c: boolean): Point;
    gd(a: any): boolean;
    protected so(a: Rect, b: Rect): void;
    protected sp(a: Rect, b: Rect): void;
    y0: ScatterFrame;
    y2: ScatterFrame;
    yy: ScatterFrame;
    yz(): ScatterFrame;
    aa2(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    abd(a: ScatterFrame, b: ScatterBaseView): void;
    o5(a: boolean, b: SeriesView): void;
    zn: boolean;
    zm: boolean;
    protected zj: boolean;
    protected zi: boolean;
    protected get_fe(): boolean;
    private zb;
    private zc;
    protected y9(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected za(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    wt(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected y8(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    dg(a: any, b: Point, c: boolean): HighlightingInfo;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected zt(): boolean;
    protected zs(): boolean;
    abo(a: ScatterFrame, b: ScatterBaseView): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p2(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    aa5(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: MarkerCollisionMode, e: IFastItemColumn$1<number>): void;
    yn(a: number, b: number): any[];
    protected yo(a: number, b: number): any[];
    protected y7: ScatterSeriesRenderManager;
    aa3(a: ScatterBaseView, b: ScatterFrame): void;
    protected aa9(a: number, b: number, c: boolean): void;
    protected aa8(a: number, b: number, c: boolean): void;
    protected abj(a: AssigningScatterStyleEventArgs): void;
    protected abi(a: AssigningScatterMarkerStyleEventArgs): void;
    abb(a: ScatterFrame, b: ScatterBaseView): void;
    abe(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    abc(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    aba(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    abf(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    abl(a: ScatterFrame, b: ScatterBaseView): void;
    private abm;
    private abn;
    he(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    rq(a: boolean): void;
    protected sf(): void;
    y1: ScatterFrame;
    rr(a: Rect, b: RenderSurface): void;
    private yx;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abk(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    ym(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    zv(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected px(a: any): void;
    iy(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private zh;
    private zw;
    private zx;
    zy: number;
    zz: number;
    private abq;
    i8(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    we(a: number[]): Point;
    wd(a: ValueLayerValueMode): Point;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    c0: MarkerManagerBase;
    protected cy: Point[];
    protected c1: ScatterBase;
    protected c6: List$1<number>;
    constructor(a: ScatterBase);
    private dh;
    private di;
    c2: ScatterTrendLineManager;
    au(): void;
    private dg;
    dj(a: Marker): Size;
    protected cz(): MarkerManagerBase;
    protected de(a: IDictionary$2<any, OwnedPoint>): void;
    c5(): List$1<Marker>;
    cx(): Point[];
    protected cw(): Point[];
    protected c4(): List$1<number>;
    c7(): void;
    dc(a: PathGeometry): void;
    c8(): void;
    dd(a: PathGeometry): void;
    df(): void;
    c3: HashPool$2<any, Marker>;
    cj(a: (arg1: Marker) => void): void;
    da(a: (arg1: Marker) => void): void;
    db(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    c9(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
